--==================================================================================  
-- Project:   PJ004672 - COWS Reporting   
-- Author:   Brad Settle  
-- Date:   03/22/2012  
-- Description:    
--     INTL Sales Ops Report.  
--     Group Type:  GOM  
--     QueryNumber: 1 = Daily  
--         2 = Weekly  
--         3 = Monthly  
--         0 = Specify start date & end date: 'mm/dd/yyyy'  
--  
-- TEST: EXEC COWS_Reporting.dbo.sp_INTLRptSalesOpsReport 0, 0,'2012/01/01','2012/04/04'  
-- Updated By:   Md M Monir  
-- Updated Date: 03/19/2018  
-- Updated Reason: SCURD_CD/CSG_LVL_CD 
-- Update date: <06/06/2018>
-- Updated by: Md M Monir  
-- Description: <To get H5 Data>  CTY_NME 
--==================================================================================  
ALTER Procedure [dbo].[sp_INTLRptSalesOpsReport]   
 @secured   BIT=0,  
 @QueryNumber  INT,  
 @inStartDtStr  VARCHAR(10)='',  
 @inEndDtStr   VARCHAR(10)=''  
AS  
BEGIN TRY  
  
 SET NOCOUNT ON;  
   
 DECLARE @startDate  DATETIME  
 DECLARE @endDate  DATETIME  
 DECLARE @today   DATETIME  
 DECLARE @startDtStr  VARCHAR(10)   
 DECLARE @dayOfWeek  INT  
   
 IF @QueryNumber=0  
  BEGIN  
   SET @startDate=CONVERT(DATETIME, @inStartDtStr, 101)  
   SET @endDate=CONVERT(DATETIME, @inEndDtStr, 101)      
   -- Add 1 day to End Date in order to cover the End Date 24-hr period  
   SET @endDate=DATEADD(day, 1, @endDate)   
  END   
 ELSE IF @QueryNumber=1  
     BEGIN       
      -- e.g. Run date is '2011-06-15' , STRT_TMST >= 2011-06-15 00:00:00.000 and STRT_TMST < 2011-06-16 00:00:00.000  
   SET @startDate=cast(CONVERT(VARCHAR(8), GETDATE(), 112) AS DATETIME)  
   SET @endDate=cast(CONVERT(VARCHAR(8), DATEADD(day, 1, GETDATE()), 112) AS DATETIME)     
  END  
 ELSE IF @QueryNumber=2  
  BEGIN  
   -- e.g. Run date is '2011-06-21' 3rd day of the week  
   -- STRT_TMST >= 2011-06-12 00:00:00.000 and STRT_TMST < 2011-06-19 00:00:00.000  
   SET @today=GETDATE()  
   SET @dayOfWeek=DATEPART(dw, @today)  
   SET @startDate=cast(CONVERT(VARCHAR(8), DATEADD(dd, -(@dayOfWeek+6), @today), 112) AS DATETIME)  
   SET @endDate=cast(CONVERT(VARCHAR(8), DATEADD(dd, -(@dayOfWeek-1), @today), 112) AS DATETIME)  
  END  
 ELSE IF @QueryNumber=3  
  BEGIN      
     SET @today=DATEADD(MONTH,0,GETDATE())  
      -- e.g. Run date is the 1st day of each month   
      -- STRT_TMST >= 2011-05-01 00:00:00.000 and STRT_TMST < 2011-06-01 00:00:00.000  
     SET @startDtStr=SUBSTRING(CONVERT(VARCHAR(10), @today, 101),1,2) + '/01/' + CAST(YEAR(@today) AS VARCHAR(4));       
   SET @startDate=CAST(@startDtStr AS DATETIME)  
   SET @endDate=CAST(CONVERT(VARCHAR(8), GETDATE()+1, 112) AS DATETIME)  
  END  
  
 --DECLARE @secured BIT=0 -- for testing purposes only  
  
 OPEN SYMMETRIC KEY FS@K3y   
 DECRYPTION BY CERTIFICATE S3cFS@CustInf0;   
  
 SELECT DISTINCT  
  CASE   
   WHEN o.ORDR_CAT_ID=1 THEN convert(varchar(50),ipo.ORDR_ID)   
   WHEN o.ORDR_CAT_ID=2 THEN fo.FTN  
   WHEN o.ORDR_CAT_ID=6 THEN fo.FTN END [CTN-FTN]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN convert(varchar(50),ipo.RELTD_ORDR_ID)  
   WHEN o.ORDR_CAT_ID=2 THEN fo.RELTD_FTN  
   WHEN o.ORDR_CAT_ID=6 THEN fo.RELTD_FTN END [Related CTN-FTN]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN ISNULL(lot.ORDR_TYPE_DES,'')  
   WHEN o.ORDR_CAT_ID=2 THEN ISNULL(lfot.FSA_ORDR_TYPE_DES,'')  
   WHEN o.ORDR_CAT_ID=6 THEN ISNULL(lfot.FSA_ORDR_TYPE_DES,'') END [Order Type]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN ISNULL(CAST(llat.LOCAL_ACCS_TYPE_ID AS VARCHAR(10)),'')  
   WHEN o.ORDR_CAT_ID=6 THEN ISNULL(CAST(fo.TTRPT_ACCS_TYPE_DES AS VARCHAR(10)),'')  
   WHEN o.ORDR_CAT_ID=2 THEN ISNULL(CAST(fo.TTRPT_ACCS_TYPE_DES AS VARCHAR(10)),'') END [Access Type]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN ISNULL(CAST(ipo.CKT_SPD_QTY AS VARCHAR(10)),'')  
   WHEN o.ORDR_CAT_ID=2 THEN ISNULL(fo.TTRPT_SPD_OF_SRVC_BDWD_DES,'')  
   WHEN o.ORDR_CAT_ID=6 THEN ISNULL(fo.TTRPT_SPD_OF_SRVC_BDWD_DES,'') END [Port Speed]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN ISNULL(lpt.PROD_TYPE_DES,'')  
   WHEN o.ORDR_CAT_ID=2 THEN ISNULL(lfpt.FSA_PROD_TYPE_DES,'')  
   WHEN o.ORDR_CAT_ID=6 THEN ISNULL(lfpt.FSA_PROD_TYPE_DES,'') END [Product Type]  
  ,ISNULL(fo.INTL_PL_PLUS_IP_CD,'') as 'IPL Flag'  
  ,ISNULL(nc.PLN_NME,'') [Existing PL#]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN ISNULL(ipo.SALS_PERSN_CID,'')  
   WHEN o.ORDR_CAT_ID=2 THEN ISNULL(foc.SALS_PERSN_PRIM_CID,'')  
   WHEN o.ORDR_CAT_ID=6 THEN ISNULL(foc.SALS_PERSN_PRIM_CID,'') END [Quota Bearing Sales]  
  ,CASE  
    
   --WHEN o.ORDR_CAT_ID=6 AND @secured = 1 AND o.SCURD_CD = 1 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))  
   --WHEN o.ORDR_CAT_ID=6 AND @secured = 1 AND o.SCURD_CD = 0 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))   
   --WHEN o.ORDR_CAT_ID=6 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NOT NULL THEN 'PRIVATE CUSTOMER'   
   --WHEN o.ORDR_CAT_ID=6 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NULL THEN ''  
   --WHEN o.ORDR_CAT_ID=2 AND @secured = 1 AND o.SCURD_CD = 1 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))  
   --WHEN o.ORDR_CAT_ID=2 AND @secured = 1 AND o.SCURD_CD = 0 THEN CONVERT(VARCHAR, DecryptByKey(si.CUST_NME))   
   --WHEN o.ORDR_CAT_ID=2 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NOT NULL THEN 'PRIVATE CUSTOMER'   
   --WHEN o.ORDR_CAT_ID=2 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)) IS NULL THEN ''   
   --WHEN o.ORDR_CAT_ID=1 AND @secured = 1 AND o.SCURD_CD = 1 THEN CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME))  
   --WHEN o.ORDR_CAT_ID=1 AND @secured = 1 AND o.SCURD_CD = 0 THEN CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME))   
   --WHEN o.ORDR_CAT_ID=1 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME)) IS NOT NULL THEN 'PRIVATE CUSTOMER'   
   --WHEN o.ORDR_CAT_ID=1 AND @secured = 0 AND o.SCURD_CD = 1 AND CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME)) IS NULL THEN ''   
   --ELSE ISNULL(CONVERT(VARCHAR, DecryptByKey(h5f2.CUST_NME)),CONVERT(VARCHAR, DecryptByKey(si.CUST_NME)))   
     
   o.ORDR_CAT_ID  
         WHEN 6 THEN  
       CASE    
       WHEN @secured = 0 AND o.CSG_LVL_ID =0 THEN  si.CUST_NME  
       WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NOT NULL THEN  'PRIVATE CUSTOMER'  
       WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NULL THEN  ''  
       ELSE  COALESCE(si.CUST_NME2,si.CUST_NME,'') END  
      WHEN 2 THEN  
       CASE    
       WHEN @secured = 0 AND o.CSG_LVL_ID =0 THEN  si.CUST_NME  
       WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NOT NULL THEN  'PRIVATE CUSTOMER'  
       WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND si.CUST_NME2 IS NULL THEN  ''  
       ELSE  COALESCE(si.CUST_NME2,si.CUST_NME,'') END  
      WHEN 1 THEN  
       CASE    
       WHEN @secured = 0 AND o.CSG_LVL_ID =0 THEN  h5f2.CUST_NME  
       WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND CONVERT(VARCHAR, DecryptByKey(csd.CUST_NME)) IS NOT NULL THEN  'PRIVATE CUSTOMER'  
       WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND CONVERT(VARCHAR, DecryptByKey(csd.CUST_NME)) IS NULL THEN  ''  
       ELSE  COALESCE(csd.CUST_NME,h5f2.CUST_NME,'') END     
    ELSE COALESCE(CONVERT(VARCHAR, DecryptByKey(csd.CUST_NME)),si.CUST_NME,si.CUST_NME2,'' )  
      
   END [Sprint Customer Name] --Secured   
  --,CONVERT(VARCHAR, DecryptByKey(oa.PRVN_NME)) [Province/Municipal]  
  ,CASE    
   WHEN @secured = 0 AND o.CSG_LVL_ID =0 THEN  oa.PRVN_NME  
   WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND CONVERT(VARCHAR, DecryptByKey(csd2.STT_PRVN_NME)) IS NOT NULL THEN  'PRIVATE CUSTOMER'  
   WHEN @secured = 0 AND o.CSG_LVL_ID >0 AND CONVERT(VARCHAR, DecryptByKey(csd2.STT_PRVN_NME)) IS NULL THEN  ''  
   ELSE  COALESCE(csd2.STT_PRVN_NME,oa.PRVN_NME,'') END   
   [Province/Municipal]   
  --,ISNULL(h5f.CUST_CTY_NME,'') [H5 City]
  ,CASE WHEN (h5f.CSG_LVL_ID>0) THEN dbo.decryptBinaryData(csd.CTY_NME) ELSE h5f.CUST_CTY_NME END AS  [H5 City] /*Monir 06062018*/  
  
  --,ISNULL(lkc5.CTRY_NME,'') [H5 Country] 
  ,CASE WHEN (h5f.CSG_LVL_ID>0) THEN lcs.CTRY_NME ELSE lkc5.CTRY_NME END [H5 Country] /*Monir 06062018*/ 
  ,CASE   
   WHEN o.ORDR_CAT_ID = 2 THEN ISNULL(CAST(zzzz.MRC AS MONEY),0)  
   WHEN o.ORDR_CAT_ID = 6 THEN ISNULL(CAST(fo.TPORT_CALC_RT_MRC_USD_AMT AS MONEY),0)   
   END [Cust Port MRC]  
  ,CASE   
   WHEN o.ORDR_CAT_ID = 2 THEN ISNULL(CAST(zzzz.NRC AS MONEY),0)  
   WHEN o.ORDR_CAT_ID = 6 THEN ISNULL(CAST(fo.TPORT_CALC_RT_NRC_USD_AMT AS MONEY),0)   
   END [Cust Port NRC]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN ISNULL(ipo.CREAT_DT,'')  
   WHEN o.ORDR_CAT_ID=2 THEN ISNULL(fo.CREAT_DT,'')  
   WHEN o.ORDR_CAT_ID=6 THEN ISNULL(fo.CREAT_DT,'') END [System Create Date]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN ISNULL(zzz.STUS_DES,'')  
   WHEN o.ORDR_CAT_ID=2 THEN ISNULL(zz.STUS_DES,'')  
   WHEN o.ORDR_CAT_ID=6 THEN ISNULL(zz.STUS_DES,'') END [Status]  
  ,CASE   
   WHEN o.ORDR_CAT_ID=1 THEN ISNULL(ipo.ORDR_CMNT_TXT,'')  
   WHEN o.ORDR_CAT_ID=2 THEN ISNULL(tt.CMNT_TXT,'')  
   WHEN o.ORDR_CAT_ID=6 THEN ISNULL(tt.CMNT_TXT,'') END [Order Comments]  
  ,ISNULL(lxr.RGN_DES,'') [Region]  
  ,CASE   
   WHEN tt.A_END_NEW_CKT_CD=1 THEN 'New Ckt'  
   WHEN tt.B_END_NEW_CKT_CD=1 THEN 'Replacing Ckt'   
   ELSE 'Neither' END [Is this a new ckt or replacing an existing ckt]  
  ,ISNULL(nc.NUA_ADR,'') [NUA]  
  ,ISNULL(nc.TOC_ADR,'') [TOC]  
 FROM COWS.dbo.ORDR o WITH (NOLOCK)   
  LEFT OUTER JOIN COWS.dbo.ORDR_ADR oa WITH (NOLOCK) ON o.ORDR_ID = oa.ORDR_ID  
  LEFT OUTER JOIN [COWS].dbo.CUST_SCRD_DATA csd2 WITH (NOLOCK) ON csd2.SCRD_OBJ_ID=oa.ORDR_ADR_ID  AND csd2.SCRD_OBJ_TYPE_ID=14  
  LEFT OUTER JOIN COWS.dbo.ORDR_NTE ont WITH (NOLOCK) ON o.ORDR_ID = ont.ORDR_ID  
  LEFT OUTER JOIN (  
   SELECT bb.ORDR_ID,FTN,RELTD_FTN,ORDR_TYPE_CD,PROD_TYPE_CD,INSTL_VNDR_CD  
   ,fcpl.TTRPT_ACCS_TYPE_DES,INTL_PL_CKT_TYPE_CD,fcpl.TTRPT_SPD_OF_SRVC_BDWD_DES,bb.CREAT_DT,INTL_PL_PLUS_IP_CD  
   ,TPORT_CALC_RT_NRC_USD_AMT, TPORT_CALC_RT_MRC_USD_AMT  
    FROM COWS.dbo.FSA_ORDR bb WITH (NOLOCK)   
    LEFT OUTER JOIN [COWS].[dbo].[FSA_ORDR_CPE_LINE_ITEM] fcpl with (nolock) on fcpl.ORDR_ID = bb.ORDR_ID  
    WHERE ORDR_ACTN_ID <> 3  
  ) fo ON o.ORDR_ID = fo.ORDR_ID    
  LEFT OUTER JOIN(SELECT ORDR_ID,SALS_PERSN_PRIM_CID   
   FROM COWS.dbo.FSA_ORDR_CUST WITH (NOLOCK) WHERE CIS_LVL_TYPE in ('H5','H6')  
  ) foc ON o.ORDR_ID = foc.ORDR_ID  
  LEFT OUTER JOIN COWS.dbo.IPL_ORDR ipo WITH (NOLOCK) ON o.ORDR_ID = ipo.ORDR_ID  
  LEFT OUTER JOIN (SELECT DISTINCT ORDR_ID,LOCAL_ACCS_TYPE_ID   
   FROM COWS.dbo.IPL_ORDR_ACCS_INFO WITH (NOLOCK) WHERE LOCAL_ACCS_TYPE_ID IS NOT NULL  
  ) llat ON llat.ORDR_ID = o.ORDR_ID   
  LEFT OUTER JOIN COWS.dbo.TRPT_ORDR tt WITH (NOLOCK) ON o.ORDR_ID = tt.ORDR_ID  
  LEFT OUTER JOIN 
  
  (SELECT   DISTINCT a.FTN,[NUA_ADR],
			CASE WHEN (o.CSG_LVL_ID>0) THEN dbo.decryptBinaryData(csd.[SITE_ADR]) ELSE a.[TOC_ADR]  END AS [TOC_ADR],
			[PLN_NME]   
   FROM COWS.dbo.NRM_CKT a WITH (NOLOCK)   
   JOIN (SELECT MIN(NRM_CKT_ID)[NRM_CKT_ID] FROM COWS.dbo.NRM_CKT WITH (NOLOCK) GROUP BY FTN) b ON b.[NRM_CKT_ID]=a.[NRM_CKT_ID]
   LEFT OUTER JOIN COWS.dbo.FSA_ORDR f WITH(NOLOCK) ON f.FTN=a.FTN
   LEFT OUTER JOIN COWS.dbo.[CUST_SCRD_DATA] csd WITH (NOLOCK) ON csd.[SCRD_OBJ_ID]=a.[NRM_CKT_ID] and csd.[SCRD_OBJ_TYPE_ID]=29
LEFT JOIN COWS.dbo.ORDR O WITH (NOLOCK) ON O.ORDR_ID=f.ORDR_ID   
  ) nc ON nc.FTN = fo.FTN  
  LEFT OUTER JOIN COWS.dbo.CKT c WITH (NOLOCK) ON c.ORDR_ID = o.ORDR_ID  
  LEFT OUTER JOIN COWS.dbo.CKT_COST cc WITH (NOLOCK) ON cc.CKT_ID = c.CKT_ID  
  LEFT OUTER JOIN COWS.dbo.H5_FOLDR h5f2 WITH (NOLOCK) ON h5f2.CUST_ID = ipo.H5_CUST_ACCT_NBR  
  LEFT OUTER JOIN [COWS].dbo.CUST_SCRD_DATA csd WITH (NOLOCK) ON csd.SCRD_OBJ_ID=h5f2.H5_FOLDR_ID  AND csd.SCRD_OBJ_TYPE_ID=6  
  LEFT OUTER JOIN COWS.dbo.H5_FOLDR h5f WITH (NOLOCK) ON h5f.H5_FOLDR_ID = o.H5_FOLDR_ID        
  LEFT OUTER JOIN COWS.dbo.LK_XNCI_RGN lxr WITH (NOLOCK) ON lxr.RGN_ID = o.RGN_ID         
  LEFT OUTER JOIN COWS.dbo.LK_CTRY lkc5 WITH (NOLOCK) ON lkc5.CTRY_CD = h5f.CTRY_CD  
  LEFT OUTER JOIN [COWS].[dbo].[LK_CTRY] lcs on CONVERT(varchar, DecryptByKey(csd.CTRY_CD)) = lcs.CTRY_CD       
  LEFT OUTER JOIN (SELECT ORDR_ID,ASN_USER_ID,ASMT_DT FROM COWS.dbo.USER_WFM_ASMT WITH (NOLOCK) WHERE GRP_ID = 1) uwa ON uwa.ORDR_ID=o.ORDR_ID  
  LEFT OUTER JOIN COWS.dbo.LK_USER lu WITH (NOLOCK) ON uwa.ASN_USER_ID = lu.[USER_ID]  
  LEFT OUTER JOIN COWS.dbo.LK_FSA_ORDR_TYPE lfot WITH (NOLOCK) ON lfot.FSA_ORDR_TYPE_CD = fo.ORDR_TYPE_CD  
  LEFT OUTER JOIN COWS.dbo.LK_ORDR_TYPE lot WITH (NOLOCK) ON lot.ORDR_TYPE_ID = ipo.ORDR_TYPE_ID  
  LEFT OUTER JOIN COWS.dbo.LK_FSA_PROD_TYPE lfpt WITH (NOLOCK) ON lfpt.FSA_PROD_TYPE_CD = fo.PROD_TYPE_CD  
  LEFT OUTER JOIN COWS.dbo.LK_PROD_TYPE lpt WITH (NOLOCK) ON lpt.PROD_TYPE_ID = ipo.PROD_TYPE_ID  
  LEFT OUTER JOIN COWS.dbo.LK_VNDR lkv WITH (NOLOCK) ON lkv.VNDR_CD = fo.INSTL_VNDR_CD  
    LEFT OUTER JOIN (SELECT ACT_TASK_ID,ORDR_ID,y.TASK_ID,STUS_ID,STUS_DES FROM (  
   SELECT ACT_TASK_ID,ORDR_ID,TASK_ID FROM COWS.dbo.ACT_TASK at WITH (NOLOCK)   
   WHERE ACT_TASK_ID = (SELECT MAX(ACT_TASK_ID)   
    FROM COWS.dbo.ACT_TASK mat WITH (NOLOCK)  
    WHERE mat.ORDR_ID=at.ORDR_ID)) y  
   JOIN (SELECT TASK_ID,STUS_ID,STUS_DES   
    FROM COWS.dbo.LK_TASK lkt WITH (NOLOCK)  
    JOIN COWS.dbo.LK_STUS lks WITH(NOLOCK) ON lks.STUS_ID=lkt.ORDR_STUS_ID) z ON z.TASK_ID=y.TASK_ID  
   ) zz on zz.ORDR_ID=fo.ORDR_ID  
    LEFT OUTER JOIN (SELECT ACT_TASK_ID,ORDR_ID,y.TASK_ID,STUS_ID,STUS_DES FROM (  
   SELECT ACT_TASK_ID,ORDR_ID,TASK_ID FROM COWS.dbo.ACT_TASK at WITH (NOLOCK)   
   WHERE ACT_TASK_ID = (SELECT MAX(ACT_TASK_ID)   
    FROM COWS.dbo.ACT_TASK mat WITH (NOLOCK)  
    WHERE mat.ORDR_ID=at.ORDR_ID)) y  
   JOIN (SELECT TASK_ID,STUS_ID,STUS_DES   
    FROM COWS.dbo.LK_TASK lkt WITH (NOLOCK)  
    JOIN COWS.dbo.LK_STUS lks WITH(NOLOCK) ON lks.STUS_ID=lkt.ORDR_STUS_ID) z ON z.TASK_ID=y.TASK_ID  
   ) zzz on zzz.ORDR_ID=ipo.ORDR_ID  
  LEFT OUTER JOIN (SELECT bb.ORDR_ID, bb.SOI_CD, bb.CUST_NME, bb.BR_CD, CONVERT(varchar, DecryptByKey(csd.CUST_NME)) AS CUST_NME2  
       FROM COWS.dbo.FSA_ORDR_CUST bb WITH (NOLOCK)  
       LEFT OUTER JOIN COWS.dbo.FSA_ORDR cc WITH (NOLOCK) ON  bb.ORDR_ID = cc.ORDR_ID   
       LEFT OUTER JOIN [COWS].dbo.CUST_SCRD_DATA csd WITH (NOLOCK) ON csd.SCRD_OBJ_ID=bb.FSA_ORDR_CUST_ID  AND csd.SCRD_OBJ_TYPE_ID=5  
    WHERE (CIS_LVL_TYPE in ('H5','H6')) AND bb.SOI_CD = (SELECT MAX(SOI_CD)  
     FROM (SELECT SOI_CD, ORDR_ID   
      FROM COWS.dbo.FSA_ORDR_CUST WITH (NOLOCK)) soi  
     WHERE soi.ORDR_ID = bb.ORDR_ID AND (CIS_LVL_TYPE in ('H5','H6')))) si ON si.ORDR_ID = fo.ORDR_ID   
  LEFT OUTER JOIN (SELECT ORDR_ID,SUM(MRC)MRC,SUM(NRC)NRC  
     FROM (SELECT ORDR_ID,ISNULL(CAST(MRC_CHG_AMT AS MONEY),0) MRC,ISNULL(CAST(REPLACE(NRC_CHG_AMT,'null','') as MONEY),0) NRC  
      FROM COWS.dbo.FSA_ORDR_BILL_LINE_ITEM WITH (NOLOCK)  
     ) x GROUP BY ORDR_ID   
   )zzzz ON zzzz.ORDR_ID = fo.ORDR_ID  
  LEFT OUTER JOIN (SELECT c.ORDR_ID,SUM(y.[ACCS_CUST_MRC])[ACCS_CUST_MRC],SUM(y.[ACCS_CUST_NRC])[ACCS_CUST_NRC]  
   FROM COWS.dbo.CKT c WITH (NOLOCK)  
    JOIN (SELECT CKT_ID,SUM([ACCS_CUST_MRC])[ACCS_CUST_MRC] ,SUM([ACCS_CUST_NRC])[ACCS_CUST_NRC]   
     FROM (SELECT CKT_ID,MAX(VER_ID)[VER],ISNULL(CAST(ACCS_CUST_MRC_IN_USD_AMT AS MONEY),0) [ACCS_CUST_MRC],ISNULL(CAST(ACCS_CUST_NRC_IN_USD_AMT AS MONEY),0) [ACCS_CUST_NRC]  
      FROM COWS.dbo.CKT_COST WITH (NOLOCK) GROUP BY CKT_ID,ACCS_CUST_MRC_IN_USD_AMT,ACCS_CUST_NRC_IN_USD_AMT  
     ) x GROUP BY CKT_ID   
    ) y ON y.CKT_ID = c.CKT_ID  
    GROUP BY c.ORDR_ID       
   ) zzzzz ON zzzzz.ORDR_ID=o.ORDR_ID  
 WHERE (ipo.ORDR_ID IS NOT NULL OR fo.FTN IS NOT NULL)  
  --AND lu.MGR_ADID = 'tll4514'   
  AND (oa.ADR_TYPE_ID = 18 OR oa.ADR_TYPE_ID = 12)  
  AND ((fo.CREAT_DT >= @startDate AND fo.CREAT_DT < @endDate) OR (ipo.CREAT_DT >= @startDate AND ipo.CREAT_DT < @endDate))   
  AND oa.CIS_LVL_TYPE in ('H5','H6')  
  AND o.DMSTC_CD = 1  
  
  
 CLOSE SYMMETRIC KEY FS@K3y   
  
 RETURN 0;  
   
END TRY  
  
BEGIN CATCH  
 DECLARE @Desc VARCHAR(200)  
 SET @Desc='EXEC COWS_Reporting.dbo.sp_INTLRptSalesOpsReport '  + CAST(@QueryNumber AS VARCHAR(4)) + ': '  
 SET @Desc=@Desc + CONVERT(VARCHAR(10), @startDate, 101) + ', ' + CONVERT(VARCHAR(10), @endDate, 101)  
 EXEC RAD_Reporting.rad.sp_ReportProcessLog null, @Desc, null, null, null;  
 RETURN 1;  
END CATCH  
  
  
  